org.apache.lucene.index

## Class FilterAtomicReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.AtomicReader
    - - org.apache.lucene.index.FilterAtomicReader

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class FilterAtomicReader
      extends AtomicReader

  A `FilterAtomicReader` contains another AtomicReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `FilterAtomicReader` itself simply implements all abstract methods of `IndexReader` with versions that pass all requests to the contained index reader. Subclasses of `FilterAtomicReader` may further override some of these methods and may also provide additional methods and fields.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `FilterAtomicReader.FilterDocsAndPositionsEnum` Base class for filtering `DocsAndPositionsEnum` implementations.
    `static class` | `FilterAtomicReader.FilterDocsEnum` Base class for filtering `DocsEnum` implementations.
    `static class` | `FilterAtomicReader.FilterFields` Base class for filtering `Fields` implementations.
    `static class` | `FilterAtomicReader.FilterTerms` Base class for filtering `Terms` implementations.
    `static class` | `FilterAtomicReader.FilterTermsEnum` Base class for filtering `TermsEnum` implementations.

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.ReaderClosedListener`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AtomicReader` | `in` The underlying AtomicReader.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterAtomicReader(AtomicReader in)` Construct a FilterAtomicReader based on the specified base reader.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `doClose()` Implements close.
    `void` | `document(int docID, StoredFieldVisitor visitor)` Expert: visits the fields of a stored document, for custom processing/loading of each field.
    `Fields` | `fields()` Returns `Fields` for this reader.
    `BinaryDocValues` | `getBinaryDocValues(String field)` Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field.
    `Object` | `getCombinedCoreAndDeletesKey()` Expert: Returns a key for this IndexReader that also includes deletions, so FieldCache/CachingWrapperFilter can find it again.
    `Object` | `getCoreCacheKey()` Expert: Returns a key for this IndexReader, so FieldCache/CachingWrapperFilter can find it again.
    `FieldInfos` | `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
    `Bits` | `getLiveDocs()` Returns the `Bits` representing live (not deleted) docs.
    `NumericDocValues` | `getNormValues(String field)` Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
    `NumericDocValues` | `getNumericDocValues(String field)` Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field.
    `SortedDocValues` | `getSortedDocValues(String field)` Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
    `SortedSetDocValues` | `getSortedSetDocValues(String field)` Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
    `Fields` | `getTermVectors(int docID)` Retrieve term vectors for this document, or null if term vectors were not indexed.
    `boolean` | `hasDeletions()` Returns true if any documents have been deleted
    `int` | `maxDoc()` Returns one greater than the largest possible document number.
    `int` | `numDocs()` Returns the number of documents in this index.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.lucene.index.AtomicReader

      `docFreq, getContext, hasNorms, termDocsEnum, termPositionsEnum, terms, totalTermFreq`

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `addReaderClosedListener, close, decRef, document, document, ensureOpen, equals, getRefCount, getTermVector, hashCode, incRef, leaves, numDeletedDocs, open, open, open, open, open, registerParentReader, removeReaderClosedListener, tryIncRef`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### in

          protected final AtomicReader in

      The underlying AtomicReader.

  - ### Constructor Detail

    - #### FilterAtomicReader

          public FilterAtomicReader(AtomicReader in)

      Construct a FilterAtomicReader based on the specified base reader.

      Note that base reader is closed if this FilterAtomicReader is closed.

      Parameters:
        `in` - specified base reader.

  - ### Method Detail

    - #### getLiveDocs

          public Bits getLiveDocs()

      Description copied from class: `AtomicReader`
      Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live). The returned instance has been safely published for use by multiple threads without additional synchronization.
      Specified by:
        `getLiveDocs` in class `AtomicReader`

    - #### getFieldInfos

          public FieldInfos getFieldInfos()

      Description copied from class: `AtomicReader`
      Get the `FieldInfos` describing all fields in this reader.
      Specified by:
        `getFieldInfos` in class `AtomicReader`

    - #### getTermVectors

          public Fields getTermVectors(int docID)
                                throws IOException

      Description copied from class: `IndexReader`
      Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).
      Specified by:
        `getTermVectors` in class `IndexReader`
      Throws:
        `IOException`

    - #### numDocs

          public int numDocs()

      Description copied from class: `IndexReader`
      Returns the number of documents in this index.
      Specified by:
        `numDocs` in class `IndexReader`

    - #### maxDoc

          public int maxDoc()

      Description copied from class: `IndexReader`
      Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
      Specified by:
        `maxDoc` in class `IndexReader`

    - #### document

          public void document(int docID,
                      StoredFieldVisitor visitor)
                        throws IOException

      Description copied from class: `IndexReader`
      Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.
      Specified by:
        `document` in class `IndexReader`
      Throws:
        `IOException`

    - #### hasDeletions

          public boolean hasDeletions()

      Description copied from class: `IndexReader`
      Returns true if any documents have been deleted
      Specified by:
        `hasDeletions` in class `IndexReader`

    - #### doClose

          protected void doClose()
                          throws IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `IOException`

    - #### fields

          public Fields fields()
                        throws IOException

      Description copied from class: `AtomicReader`
      Returns `Fields` for this reader. This method may return null if the reader has no postings.
      Specified by:
        `fields` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getCoreCacheKey

          public Object getCoreCacheKey()

      Expert: Returns a key for this IndexReader, so FieldCache/CachingWrapperFilter can find it again. This key must not have equals()/hashCode() methods, so "equals" means "identical".

      If the subclass of FilteredIndexReader modifies the contents (but not liveDocs) of the index, you must override this method to provide a different key.

      Overrides:
        `getCoreCacheKey` in class `IndexReader`

    - #### getCombinedCoreAndDeletesKey

          public Object getCombinedCoreAndDeletesKey()

      Expert: Returns a key for this IndexReader that also includes deletions, so FieldCache/CachingWrapperFilter can find it again. This key must not have equals()/hashCode() methods, so "equals" means "identical".

      If the subclass of FilteredIndexReader modifies the liveDocs, you must override this method to provide a different key.

      Overrides:
        `getCombinedCoreAndDeletesKey` in class `IndexReader`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getNumericDocValues

          public NumericDocValues getNumericDocValues(String field)
                                               throws IOException

      Description copied from class: `AtomicReader`
      Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getNumericDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getBinaryDocValues

          public BinaryDocValues getBinaryDocValues(String field)
                                             throws IOException

      Description copied from class: `AtomicReader`
      Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getBinaryDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getSortedDocValues

          public SortedDocValues getSortedDocValues(String field)
                                             throws IOException

      Description copied from class: `AtomicReader`
      Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getSortedSetDocValues

          public SortedSetDocValues getSortedSetDocValues(String field)
                                                   throws IOException

      Description copied from class: `AtomicReader`
      Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedSetDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getNormValues

          public NumericDocValues getNormValues(String field)
                                         throws IOException

      Description copied from class: `AtomicReader`
      Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getNormValues` in class `AtomicReader`
      Throws:
        `IOException`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.